Loading...
Searching...
No Matches
Lattice Class Reference
Collaboration diagram for Lattice:
[legend]

## Classes

struct | symbol_t
struct | Arc
struct | Node

## Public Member Functions

bool | determinise ()
bool | prune ()
bool | minimise ()
bool | expand ()
Node * | start_node ()
bool | accepts (EST_TList< symbol_t * > &string)
float | viterbi_transduce (EST_TList< EST_String > &input, EST_TList< Arc * > &path, EST_Litem *current_symbol=NULL, Node *start_node=NULL)
float | viterbi_transduce (EST_Track &observations, EST_TList< Arc * > &path, float &score, int current_frame=0, Node *start_node=NULL)
float | qmap_index_to_value (int index)
int | qmap_value_to_index (float value)
EST_String | nmap_index_to_name (int index)
int | nmap_name_to_index (const EST_String &name)
symbol_t * | alphabet_index_to_symbol (int index)
int | alphabet_symbol_to_index (symbol_t *sym)

## Protected Member Functions

EST_String | name_as_string (EST_IList &l)
int | alphabet_index_lookup (int nmap_index, int qmap_index)
bool | final (Node *n)
bool | build_transition_function ()
bool | build_distinguished_state_table (bool **&dst)
bool | build_distinguished_state_table_direct (bool **&dst)
bool | build_distinguished_state_table_from_transition_function (bool **&dst)
void | sort_arc_lists ()
bool | link (Node *n1, Node *n2, int label)
void | merge_nodes (EST_TList< Node * > &l)
void | merge_arcs ()
void | prune_arc (Node *node, Arc *arc)
void | prune_arcs (Node *node, EST_TList< Arc * > arcs)
void | remove_arc_from_nodes_out_list (Node *n, Arc *a)
int | node_index (Node *n)

## Protected Attributes

float | qmap_error_margin
EST_FVector | qmap
EST_TVector< EST_String > | nmap
EST_TVector< symbol_t > | alphabet
int | e_move_symbol_index
EST_TList< Node * > | nodes
EST_TList< Node * > | final_nodes
int ** | tf

## Friends

class | Lattice_Language_Model
ostream & | operator<< (ostream &s, const Lattice::symbol_t &sy)
ostream & | operator<< (ostream &s, const Lattice::Node &n)
ostream & | operator<< (ostream &s, const Lattice::Arc &n)
bool | save (Lattice &lattice, EST_String filename)
bool | load (Lattice &lattice, EST_String filename)

## Detailed Description

Definition at line 47 of file EST_lattice.h.

## Constructor & Destructor Documentation

## Lattice()

Lattice::Lattice | ( |  | ) |

Definition at line 44 of file EST_lattice.cc.

## ~Lattice()

Lattice::~Lattice | ( |  | ) |

Definition at line 50 of file EST_lattice.cc.

## Member Function Documentation

## name_as_string()

EST_String Lattice::name_as_string | ( | EST_IList & | l | ) |

protected

Definition at line 1498 of file EST_lattice.cc.

## alphabet_index_lookup()

int Lattice::alphabet_index_lookup | ( | int | nmap_index,
|  | int | qmap_index )

protected

Definition at line 1511 of file EST_lattice.cc.

## final()

bool Lattice::final | ( | Node * | n | ) |

protected

Definition at line 1486 of file EST_lattice.cc.

## build_transition_function()

bool Lattice::build_transition_function | ( |  | ) |

protected

Definition at line 1591 of file EST_lattice.cc.

## build_distinguished_state_table()

bool Lattice::build_distinguished_state_table | ( | bool **& | dst | ) |

protected

Definition at line 713 of file EST_lattice.cc.

## build_distinguished_state_table_direct()

bool Lattice::build_distinguished_state_table_direct | ( | bool **& | dst | ) |

protected

Definition at line 777 of file EST_lattice.cc.

## build_distinguished_state_table_from_transition_function()

bool Lattice::build_distinguished_state_table_from_transition_function | ( | bool **& | dst | ) |

protected

Definition at line 861 of file EST_lattice.cc.

## sort_arc_lists()

void Lattice::sort_arc_lists | ( |  | ) |

protected

Definition at line 691 of file EST_lattice.cc.

## link()

bool Lattice::link | ( | Node * | n1,
|  | Node * | n2,
|  | int | label )

protected

Definition at line 661 of file EST_lattice.cc.

## merge_nodes()

void Lattice::merge_nodes | ( | EST_TList< Node * > & | l | ) |

protected

Definition at line 1056 of file EST_lattice.cc.

## merge_arcs()

void Lattice::merge_arcs | ( |  | ) |

protected

Definition at line 1110 of file EST_lattice.cc.

## prune_arc()

void Lattice::prune_arc | ( | Node * | node,
|  | Arc * | arc )

protected

Definition at line 1173 of file EST_lattice.cc.

## prune_arcs()

void Lattice::prune_arcs | ( | Node * | node,
|  | EST_TList< Arc * > | arcs )

protected

Definition at line 1159 of file EST_lattice.cc.

## remove_arc_from_nodes_out_list()

void Lattice::remove_arc_from_nodes_out_list | ( | Node * | n,
|  | Arc * | a )

protected

Definition at line 1191 of file EST_lattice.cc.

## node_index()

int Lattice::node_index | ( | Node * | n | ) |

protected

Definition at line 1338 of file EST_lattice.cc.

## determinise()

bool Lattice::determinise | ( |  | ) |

Definition at line 428 of file EST_lattice.cc.

## minimise()

bool Lattice::minimise | ( |  | ) |

Definition at line 915 of file EST_lattice.cc.

## expand()

bool Lattice::expand | ( |  | ) |

Definition at line 1356 of file EST_lattice.cc.

## start_node()

Lattice::Node * Lattice::start_node | ( |  | ) |

Definition at line 56 of file EST_lattice.cc.

## accepts()

bool Lattice::accepts | ( | EST_TList< symbol_t * > & | string | ) |

Definition at line 1640 of file EST_lattice.cc.

## viterbi_transduce() [1/2]

float Lattice::viterbi_transduce | ( | EST_TList< EST_String > & | input,
|  | EST_TList< Arc * > & | path,
|  | EST_Litem * | current_symbol = NULL,
|  | Node * | start_node = NULL )

Definition at line 1648 of file EST_lattice.cc.

## viterbi_transduce() [2/2]

float Lattice::viterbi_transduce | ( | EST_Track & | observations,
|  | EST_TList< Arc * > & | path,
|  | float & | score,
|  | int | current_frame = 0,
|  | Node * | start_node = NULL )

Definition at line 1700 of file EST_lattice.cc.

## qmap_index_to_value()

float Lattice::qmap_index_to_value | ( | int | index | ) |

Definition at line 1289 of file EST_lattice.cc.

## qmap_value_to_index()

int Lattice::qmap_value_to_index | ( | float | value | ) |

Definition at line 1301 of file EST_lattice.cc.

## nmap_index_to_name()

EST_String Lattice::nmap_index_to_name | ( | int | index | ) |

Definition at line 1225 of file EST_lattice.cc.

## nmap_name_to_index()

int Lattice::nmap_name_to_index | ( | const EST_String & | name | ) |

Definition at line 1237 of file EST_lattice.cc.

## alphabet_index_to_symbol()

Lattice::symbol_t * Lattice::alphabet_index_to_symbol | ( | int | index | ) |

Definition at line 1522 of file EST_lattice.cc.

## alphabet_symbol_to_index()

int Lattice::alphabet_symbol_to_index | ( | Lattice::symbol_t * | sym | ) |

Definition at line 1534 of file EST_lattice.cc.

## Friends And Related Symbol Documentation

## Lattice_Language_Model

friend class Lattice_Language_Model

friend

Definition at line 200 of file EST_lattice.h.

## operator<< [1/3]

ostream & operator<< | ( | ostream & | s,
|  | const Lattice::symbol_t & | sy )

friend

Definition at line 305 of file EST_lattice.h.

## operator<< [2/3]

ostream & operator<< | ( | ostream & | s,
|  | const Lattice::Node & | n )

friend

Definition at line 312 of file EST_lattice.h.

## operator<< [3/3]

ostream & operator<< | ( | ostream & | s,
|  | const Lattice::Arc & | n )

friend

Definition at line 318 of file EST_lattice.h.

## save

bool save | ( | Lattice & | lattice,
|  | EST_String | filename )

friend

Definition at line 47 of file EST_lattice_io.cc.

## load

bool load | ( | Lattice & | lattice,
|  | EST_String | filename )

friend

Definition at line 132 of file EST_lattice_io.cc.

## Member Data Documentation

## qmap_error_margin

float Lattice::qmap_error_margin

protected

Definition at line 100 of file EST_lattice.h.

## qmap

EST_FVector Lattice::qmap

protected

Definition at line 103 of file EST_lattice.h.

## nmap

EST_TVector<EST_String> Lattice::nmap

protected

Definition at line 106 of file EST_lattice.h.

## alphabet

EST_TVector<symbol_t> Lattice::alphabet

protected

Definition at line 112 of file EST_lattice.h.

## e_move_symbol_index

int Lattice::e_move_symbol_index

protected

Definition at line 113 of file EST_lattice.h.

## nodes

EST_TList<Node*> Lattice::nodes

protected

Definition at line 125 of file EST_lattice.h.

## final_nodes

EST_TList<Node*> Lattice::final_nodes

protected

Definition at line 129 of file EST_lattice.h.

## tf

int** Lattice::tf

protected

Definition at line 135 of file EST_lattice.h.

The documentation for this class was generated from the following files:

- include/EST_lattice.h
- grammar/ngram/EST_lattice.cc